# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%bcond_without repolib

Name:           maven-bundle-plugin
Version:        2.3.5
Release:        1%{?dist}
Summary:        Maven Bundle Plugin

Group:          Development/Tools
License:        ASL 2.0
URL:            http://felix.apache.org
# svn export http://svn.apache.org/repos/asf/felix/releases/maven-bundle-plugin-2.3.5/ && tar czf maven-bundle-plugin-2.3.5.tgz maven-bundle-plugin-2.3.5/
Source0:        maven-bundle-plugin-2.3.5.tgz
Source1:        %{name}-jpp-depmap.xml

# Apply the following patch for plexus-utils 2
Patch0:         %{name}-BundlePlugin.patch
BuildRequires:  bnd1 >= 0:1.43
BuildRequires:  plexus-utils >= 0:1.5.15
BuildRequires:  apache-felix-osgi-core >= 0:1.4.0
BuildRequires:  apache-felix-osgi-service-obr >= 0:1.0.2
BuildRequires:  apache-felix-bundlerepository >= 0:1.6.4
BuildRequires:  kxml2 >= 0:2.2.2
BuildRequires:  maven-shared-dependency-tree >= 1.1
BuildRequires:  maven-wagon >= 1.0-0.2.b2
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-surefire-plugin >= 2.3
BuildRequires:  maven-surefire-provider-junit4 >= 2.3
BuildRequires:  maven-doxia-sitetools
BuildRequires:  felix-parent
# XXX: 1.0-alpha-7
BuildRequires: plexus-archiver >= 0:1.0
# XXX: 1.0-alpha-9-stable-1
BuildRequires: plexus-containers-container-default >= 0:1.0
Requires: bnd1 >= 0:1.43
Requires: plexus-utils >= 0:1.5.15
Requires: apache-felix-osgi-core >= 0:1.4.0
Requires: apache-felix-osgi-service-obr >= 0:1.0.2
Requires: apache-felix-bundlerepository >= 0:1.6.4
Requires: kxml2 >= 0:2.2.2
Requires: maven2
Requires: maven-shared-archiver
Requires: maven-shared-dependency-tree
Requires: maven-shared-osgi
Requires: maven-wagon
# XXX: 1.0-alpha-7
Requires: plexus-archiver >= 0:1.0
# XXX: 1.0-alpha-9-stable-1
Requires: plexus-containers-container-default >= 0:1.0
Requires: felix-parent
Obsoletes:      maven-plugin-bundle < %{epoch}:%{version}-%{release}
Provides:       maven-plugin-bundle = %{epoch}:%{version}-%{release}

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch: noarch

%description
Provides a maven plugin that supports creating an OSGi bundle
from the contents of the compilation classpath along with its
resources and dependencies. Plus a zillion other features.

%package javadoc
Group:          Documentation
Summary:        Javadoc for %{name}
Requires:       jpackage-utils

%description javadoc
API documentation for %{name}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n maven-bundle-plugin-%{version}
%patch0 -p0 -b .sav0

%build
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
%{_bindir}/mvn-jpp -e \
     -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
     -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} \
     -Dmaven2.jpp.depmap.file=%{SOURCE1} \
     deploy javadoc:aggregate

#export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
#%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
#        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
#         package javadoc:aggregate

%install
rm -rf %{buildroot}

# jars
install -d -m 0755 %{buildroot}%{_javadir}
install -m 644 target/maven-bundle-plugin-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
ln -s %{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}.jar

%add_to_maven_depmap org.apache.felix maven-bundle-plugin %{version} JPP %{name}

# poms
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
install -pm 644 pom.xml \
    %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom

# javadoc
install -d -m 0755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/api*/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
# repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
%{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root,-)
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(-,root,root,-)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Mon Oct 17 2011 Ralph Apel <r.apel@r-apel.de> 0:2.3.5-1
- 2.3.5 

* Thu Sep 15 2011 David Walluck <dwalluck@redhat.com> 0:2.0.0-2
- use (poorly named) maven-shared-archiver, not maven-archiver

* Thu Sep 15 2011 David Walluck <dwalluck@redhat.com> 0:2.0.0-1
- release

